code    segment
        assume  cs:code
        org     100h

.586p

start:  mov     ax,offset mcopyr
        push    ax
        call    write16
        mov     ax,offset mdochks
        push    ax
        call    write16
        call    chkTSC                  ;check for TSC (including CPU and NPU)
        jc      exitRM
        call    chkRM                   ;check for real mode
        jnb     exitRM
        call    chkMEM                  ;check for 4mb
        jc      exitRM
        call    A20on
        jc      exitRM
        push    offset mtoGB4
        call    write16
        call    fillGDT                 ;fill GDT
        push    sel_data4gb
        call    setGDT                  ;switch to flat mode
        call    chkGB4                  ;check flat mode
        jc      exitPM

encryptstart     equ $

        push    offset mtransf          ;test cache
        call    write
        call    chkcache
        call    writeci                 ;write cache info
        push    offset mCMA             ;cacheable memory area
        call    write
        call    chkCMA
        mov     al,byte ptr cs:oldLED   ;restore LED state
        call    setLED
        jmp     exitPM

        include chkcache.inc
        include strings.inc

exitPM: push    offset mfrmGB4
        call    write
        push    sel_seg64kb
        call    setGDT                  ;switch to 64kb segs
exitRM: mov     ax,4c00h
        int     21h

        include cpuclock.inc
        include flatmode.inc
        include a20.inc
        include checks.inc
        include write.inc
        include data.inc

;        mov     cx,1
;        mov     si,offset encryptstart
;decr:   add     byte ptr cs:[si],cl
;        ror     word ptr cs:[si],cl
;        inc     si
;        inc     cx
;        cmp     cx,encryptend-encryptstart
;        jb      decr

code    ends
        end     start